package com.sincere.wechatbusiness.controller;

import com.alibaba.fastjson.JSONObject;
import com.sincere.wechatbusiness.dto.BaseDto;
import com.sincere.wechatbusiness.model.Channel;
import com.sincere.wechatbusiness.model.Order;
import com.sincere.wechatbusiness.model.Users;
import com.sincere.wechatbusiness.model.WxPay;
import com.sincere.wechatbusiness.service.ChannelService;
import com.sincere.wechatbusiness.utils.HttpClientUtils;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;

@RestController
@RequestMapping("reportVoluntary")
public class ReportVoluntaryController {

    @Value("${reportVoluntary}")
    private String domain ;

    @Autowired
    ChannelService channelService;

    private static String appId = "wxd055a716238e1bd7";
    private static String secret = "c6912d34732b65116b8b4e9d5f8a81a5";

    @ApiOperation("获取支付成功之后分享列表 coupon_type AI 1 || 专家 2 ")
    @RequestMapping(value = "/getShareCouponList" , method = RequestMethod.GET)
    public JSONObject GetShareCouponList(int coupon_type) {
        String url = domain + "/h5/order/getShareCouponList?coupon_type="+coupon_type;
        return HttpClientUtils.httpGet(url);
    }

    @ApiOperation("领券 coupon_type AI 1 || 专家 2 ; type 1订购 2分享 ")
    @RequestMapping(value = "/getCoupon" , method = RequestMethod.GET)
    public JSONObject GetCoupon(int coupon_type,int type,String phone) {
        String url = domain + "/h5/order/getCoupon?coupon_type="+coupon_type+"&type="+type+"&phone="+phone;
        return HttpClientUtils.httpGet(url);
    }

    @RequestMapping(value = "GetPackageList",method = RequestMethod.POST)
    @ApiOperation(value = "获取代理商品列表")
    public JSONObject GetPackageList(){
        String url = domain+"/University/getPackageList" ;
        return HttpClientUtils.httpGet(url);
    }

    @RequestMapping(value = "GetDiscountPackage",method = RequestMethod.GET)
    @ApiOperation(value = "获取商品详情")
    public JSONObject GetDiscountPackage(int id){
        String url = domain+"/University/getPackageById?id="+id ;
        return HttpClientUtils.httpGet(url);
    }

    @RequestMapping(value = "AddVerificationCode",method = RequestMethod.GET)
    @ApiOperation(value = "获取验证码")
    public JSONObject AddVerificationCode(String mobile){
        String url = domain+"/h5/MyVoluntary/AddVerificationCode?code=206&mobile="+mobile+"&type=1" ;
        return HttpClientUtils.httpGet(url);
    }

    @RequestMapping(value = "CheckCodeIsRight",method = RequestMethod.GET)
    @ApiOperation(value = "判断验证码是否正确")
    public JSONObject CheckCodeIsRight(String mobile, String captcha){
        String url = domain+"/h5/MyVoluntary/CheckCodeIsRight?mobile="+mobile+"&captcha="+captcha ;
        return HttpClientUtils.httpGet(url);
    }

    @RequestMapping(value = "AddUser",method = RequestMethod.POST)
    @ApiOperation(value = "新增用户")
    public JSONObject AddUser(@RequestBody Users users){
        JSONObject object = new JSONObject();
        object.put("phone",users.getPhone());
        object.put("channelId",users.getChannelId());
        object.put("agentId",users.getAgentId());
        object.put("userType",1);
        return HttpClientUtils.httpPostJson(domain+"/admin/Voluntary/AddUser",object.toJSONString());
    }

    @RequestMapping(value = "GetAddOrderDetail",method = RequestMethod.POST)
    @ApiOperation(value = "生成预支付订单并返回详情")
    public JSONObject GetAddOrderDetail(@RequestBody Order order) {
        try{
            JSONObject object = new JSONObject();
            object.put("account",order.getAccount());
            object.put("expert_id",0);
            object.put("paymoney",order.getPaymoney());
            object.put("payway",2);
            object.put("product_detail","升学汇产品-代理商");
            object.put("product_id",order.getProduct_id());
            object.put("product_name",order.getProduct_name());
            object.put("type",order.getProduct_id());
            object.put("user_name",order.getUser_name());
            object.put("buycount",0);
            object.put("score_id",0);
            object.put("channelId",order.getChannelId());
            object.put("agentId",order.getAgentId());
            object.put("address",order.getAddress());
            return HttpClientUtils.httpPostJson(domain+"/University/GetAddOrderDetail",object.toJSONString());
        }catch (Exception e){
            e.printStackTrace();
        }
        return null ;
    }

    @RequestMapping(value = "WxPay",method = RequestMethod.POST)
    @ApiOperation(value = "微信支付")
    public JSONObject WxPay(@RequestBody WxPay pay){
        JSONObject object = new JSONObject();
        object.put("attach",pay.getAttach());
        object.put("notify_url",domain+"/Payment/WXPayBack");
        object.put("outTradeNo",pay.getOutTradeNo());
        object.put("payType",2);
        object.put("payWay",2);
        object.put("productId",pay.getProductId());
        object.put("subject",pay.getSubject());
        object.put("totalFee",pay.getTotalFee());
        object.put("coupon_num",pay.getCoupon_num());
        object.put("openid",pay.getOpenid());
        return HttpClientUtils.httpPostJson(domain+"/Payment/WxPay",object.toJSONString());
    }


    @RequestMapping(value = "getData",method = RequestMethod.GET)
    @ApiOperation(value = "type 1 ai  2 expert")
    public JSONObject getData(int type){
        String url = domain+"/data/getData?type="+type ;
        return HttpClientUtils.httpGet(url);
    }

    @ApiOperation("获取商品列表 全部列表point传0  好评point传5")
    @RequestMapping(value = "/getEvaluationList" , method = RequestMethod.GET)
    public JSONObject getEvaluationList(int packageId , int point , int page , int pageSize){
        String url = domain+"/h5/order/getEvaluationList?packageId="+packageId+"&point="+point+"&page="+page+"&pageSize="+pageSize ;
        return HttpClientUtils.httpGet(url);
    }

    @ApiOperation("获取小程序动态码")
    @RequestMapping(value = "/downloadSmallRoutine" , method = RequestMethod.GET)
    public void downloadSmallRoutine(int channelId, HttpServletResponse response){
        Channel channel = channelService.getDetail(channelId);
        if(StringUtils.isBlank(channel.getReportRoutineUrl())){
            createRoutine(channelId);
            String url = "D:\\report\\img\\smallRoutine\\"+channelId+".png" ;
            channel.setReportRoutineUrl(url);
            channelService.updateRoutine(channelId,url);
        }
        try{
            response.setHeader("Content-Disposition", "attachment;filename="+ URLEncoder.encode(channel.getName()+"动态码.png", "utf-8"));
            InputStream in = new FileInputStream(channel.getReportRoutineUrl());
            OutputStream out = response.getOutputStream();
            byte [] by = new byte[1024];
            int i = 0;
            while((i=in.read(by))!=-1) {
                out.write(by,0,i);
            }
            in.close();
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    public void createRoutine(int channelId){
        String url = "https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid="+appId+"&secret="+secret;
        JSONObject object = HttpClientUtils.httpGet(url) ;
        String token = object.get("access_token").toString();
        try {
            URL imgUrl = new URL("https://api.weixin.qq.com/wxa/getwxacodeunlimit?access_token="+token);
            HttpURLConnection httpURLConnection = (HttpURLConnection) imgUrl.openConnection();
            httpURLConnection.setRequestMethod("POST");// 提交模式
            // conn.setConnectTimeout(10000);//连接超时 单位毫秒
            // conn.setReadTimeout(2000);//读取超时 单位毫秒
            // 发送POST请求必须设置如下两行
            httpURLConnection.setDoOutput(true);
            httpURLConnection.setDoInput(true);
            // 获取URLConnection对象对应的输出流
            PrintWriter printWriter = new PrintWriter(httpURLConnection.getOutputStream());
            // 发送请求参数
            JSONObject paramJson = new JSONObject();
            paramJson.put("scene", "channel="+channelId);
            paramJson.put("page", "pages/index/index");
            paramJson.put("width", 430);
            paramJson.put("auto_color", true);
            printWriter.write(paramJson.toString());
            // flush输出流的缓冲
            printWriter.flush();
            //开始获取数据
            BufferedInputStream bis = new BufferedInputStream(httpURLConnection.getInputStream());
            OutputStream os = new FileOutputStream(new File("D:\\report\\img\\smallRoutine\\"+channelId+".png"));
            int len;
            byte[] arr = new byte[1024];
            while ((len = bis.read(arr)) != -1)
            {
                os.write(arr, 0, len);
                os.flush();
            }
            os.close();
        }catch (Exception e) {
            e.printStackTrace();
        }
    }

    @ApiOperation("获取渠道商列表")
    @RequestMapping(value = "/getChannelList" , method = RequestMethod.GET)
    public BaseDto getChannelList(String name , int page , int pageSize ){
        BaseDto result = new BaseDto();
        result.setData(channelService.getReportChannel(page,pageSize,name));
        return result ;
    }

    @ApiOperation("获取渠道商推广的用户")
    @RequestMapping(value = "/getUserList" , method = RequestMethod.GET)
    public JSONObject getUserList(int channelId , int page , int pageSize){
        JSONObject search = new JSONObject();
        search.put("userType",1);
        search.put("page",page);
        search.put("pageSize",pageSize);
        search.put("channelId",channelId);
        String url = domain+"/admin/Voluntary/GetUserList";
        return HttpClientUtils.httpPostJson(url,search.toJSONString());
    }
}
