package com.sincere.wechatbusiness.controller;

import com.alibaba.fastjson.JSONObject;
import com.sincere.wechatbusiness.mapper.ChannelMapper;
import com.sincere.wechatbusiness.model.AccessToken;
import com.sincere.wechatbusiness.model.Token;
import com.sincere.wechatbusiness.service.BannerService;
import com.sincere.wechatbusiness.service.ChannelProductService;
import com.sincere.wechatbusiness.service.ChannelService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Calendar;
import java.util.Date;

@RestController
public class TokenController {

    @Autowired
    ChannelService channelService ;

    @Autowired
    ChannelMapper channelMapper;

    @Autowired
    ChannelProductService channelProductService ;

    @Autowired
    BannerService bannerService ;

    private static String appId = "wx6078ff3f67524996" ;
    private static String secret = "8a0465b8ad0f000f568f48853e2818c8" ;

    @ApiOperation(value = "获取分享token")
    @RequestMapping(value = "getToken",method = RequestMethod.GET)
    public String getToken(){
        AccessToken accessToken=channelService.getAccessToken();
        Token token=new Token();
        if(accessToken!=null) {
            Calendar dateOne=Calendar.getInstance();
            Calendar dateTwo=Calendar.getInstance();
            dateOne.setTime(new Date());
            dateTwo.setTime(accessToken.getCreateTime());
            long timeOne=dateOne.getTimeInMillis();
            long timeTwo=dateTwo.getTimeInMillis();
            long minute=(timeOne-timeTwo)/(1000*60);

            if(minute<60) token.setAccess_token(accessToken.getAccessToken());
            else{
                token=getAccessToken(appId,secret);
                accessToken.setAccessToken(token.getAccess_token());
                channelService.insertAccessToken(accessToken);
            }
        }
        else {
            token=getAccessToken(appId,secret);
            accessToken=new AccessToken();
            accessToken.setAccessToken(token.getAccess_token());
            channelService.insertAccessToken(accessToken);
        }
        return accessToken.getAccessToken() ;
    }

    public Token getAccessToken(String appID, String appSecret) {
        Token token = new Token();
        String url = "https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid=" + appID + "&secret="
                + appSecret;
        try {
            URL getUrl=new URL(url);
            HttpURLConnection http=(HttpURLConnection)getUrl.openConnection();
            http.setRequestMethod("GET");
            http.setRequestProperty("Content-Type",
                    "application/x-www-form-urlencoded");
            http.setDoOutput(true);
            http.setDoInput(true);


            http.connect();
            InputStream is = http.getInputStream();
            int size = is.available();
            byte[] b = new byte[size];
            is.read(b);

            String message = new String(b, "UTF-8");
            JSONObject json = JSONObject.parseObject(message);


            token.setAccess_token(json.getString("access_token"));
            token.setExpires_in(new Integer(json.getString("expires_in")));
        } catch (MalformedURLException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return token;
    }

//    @RequestMapping(value = "test",method = RequestMethod.GET)
//    public void test(){
//        try {
//            FileReader fr = new FileReader("C:\\Users\\chen\\Desktop\\name.txt");
//            BufferedReader bf = new BufferedReader(fr);
//            String str;
//            // 按行读取字符串
//            while ((str = bf.readLine()) != null) {
//                Channel channel = channelMapper.getByName(str+"团购");
//                int pageView = channelService.getPageViewCount(channel.getId(),0,3);
//                int register = channelService.getRegisterCount(channel.getId(),0,3);
//                int order = channelService.getOrderCount(channel.getId(),0,3);
//                System.out.println(str+"---浏览量：" + pageView+";---注册量:"+register+";---订单量："+order);
//            }
//            bf.close();
//            fr.close();
//        } catch (IOException e) {
//            e.printStackTrace();
//        }
//    }

//    @RequestMapping(value = "test2",method = RequestMethod.GET)
//    public void test2(){
//        try {
//            FileReader fr = new FileReader("C:\\Users\\chen\\Desktop\\company.txt");
//            BufferedReader bf = new BufferedReader(fr);
//            String str;
//            // 按行读取字符串
//            while ((str = bf.readLine()) != null) {
//                String[] msg = str.split(",");
//                Channel channel = new Channel();
//                channel.setName("顺治"+msg[0]);
//                channel.setMobile(msg[1]);
//                channel.setProvince("浙江省");
//                channel.setCity("绍兴市");
//                channel.setTemplateId(4);
//                channel.setState(1);
//                channelService.insert(channel);
//                for(int i = 1 ; i <= 2; i++){
//                    ChannelProduct channelProduct = new ChannelProduct();
//                    channelProduct.setChannelId(channel.getId());
//                    JSONObject jsonObject = HttpClientUtils.httpGet("https://proxy.shunzhi.net:51314/University/getPackageById?id="+i);
//                    String data = jsonObject.getString("data");
//                    DiscountPackage model= JSON.parseObject(data,new TypeReference<DiscountPackage>(){});
//                    channelProduct.setChannelTitle(model.getPackage_name());
//                    channelProduct.setChannelImg(model.getPhoto());
//                    channelProduct.setChannelRequire(model.getDescribe());
//                    channelProduct.setChannelExplain(model.getRequire());
//                    channelProduct.setProductId(i);
//                    channelProduct.setProductName(model.getPackage_name());
//                    channelProduct.setPrice(model.getPrice());
//                    channelProduct.setImgUrl(model.getPhoto());
//                    if(i == 1){
//                        channelProduct.setChannelPrice("199");
//                    }else {
//                        channelProduct.setChannelPrice("999");
//                    }
//                    channelProductService.insert(channelProduct);
//                }
//            }
//            bf.close();
//            fr.close();
//        } catch (IOException e) {
//            e.printStackTrace();
//        }
//    }


//    @RequestMapping(value = "test3",method = RequestMethod.GET)
//    public void test3(){
//        try {
//            FileReader fr = new FileReader("C:\\Users\\chen\\Desktop\\company.txt");
//            BufferedReader bf = new BufferedReader(fr);
//            String str;
//            // 按行读取字符串
//            List<ChannelProduct> list = channelProductService.getList(1472);
//            ChannelProduct aiProduct = new ChannelProduct();
//            ChannelProduct expertProduct = new ChannelProduct();
//            //List<Banner> banners = bannerService.getList(1472);
//            for(ChannelProduct channelProduct : list){
//                if(channelProduct.getProductId() == 1){
//                    aiProduct = channelProduct;
//                }
//                if(channelProduct.getProductId() == 2){
//                    expertProduct = channelProduct;
//                }
//            }
//            while ((str = bf.readLine()) != null) {
//                String name = str.split(",")[0];
//                Channel channel = channelMapper.getByName("顺治"+name);
//                List<ChannelProduct> products = channelProductService.getList(channel.getId());
//                int ai = 0, expert = 0 ;
//                for(ChannelProduct channelProduct : products){
//                    if(channelProduct.getProductId() == 1){
//                        ai = channelProduct.getId();
//                        channelProduct.setChannelRequire(null);
//                        channelProduct.setChannelExplain(aiProduct.getChannelExplain());
//                        channelProductService.updateChannelProductMsg(channelProduct);
//                    }else {
//                        expert = channelProduct.getId();
//                        channelProduct.setChannelRequire(null);
//                        channelProduct.setChannelExplain(expertProduct.getChannelExplain());
//                        channelProductService.updateChannelProductMsg(channelProduct);
//                    }
//                }
//
////                bannerService.deleteChannelBanner(channel.getId());
////                for(Banner banner : banners){
////                    if(banner.getLinkUrl().equals("http://market.myjxt.com/wap/index.html#/CommodityDetail?id=1518&productId=1")){
////                        banner.setLinkUrl("http://market.myjxt.com/wap/index.html#/CommodityDetail?id="+ai+"&productId=1");
////                    }else if(banner.getLinkUrl().equals("http://market.myjxt.com/wap/index.html#/CommodityDetail?id=1517&productId=2")){
////                        banner.setLinkUrl("http://market.myjxt.com/wap/index.html#/CommodityDetail?id="+expert+"&productId=2");
////                    }
////                    banner.setChannelId(channel.getId());
////                    bannerService.copy(banner);
////                }
//            }
//            bf.close();
//            fr.close();
//        } catch (IOException e) {
//            e.printStackTrace();
//        }
//    }


}
