package com.sincere.wechatbusiness.mapper;

import com.sincere.wechatbusiness.model.*;
import org.apache.ibatis.annotations.Param;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

public interface ChannelMapper {

    List<Channel> getReportChannel(@Param("name") String name);
    int getReportChannelCount(@Param("name") String name);

    Channel getByName(String name);

    List<Channel> getListByTemplate(int templateId);

    List<Channel> getList(Channel channel);

    int getListCount(Channel channel);

    Channel getDetail(int id);

    int insert(Channel channel);

    int update(Channel channel);

    int deleteChannel(int id);

    int updateRoutine(@Param("id")int id , @Param("reportRoutineUrl")String reportRoutineUrl);

    List<Area> getProvince();

    List<Area> getCity(String areaCode);

    List<Area> getArea(String areaCode);

    List<Template> getTemplateList();

    Manager getManagerDetail(String mobile);

    int insertLog(Log log);

    int getRegisterCount(@Param("channelId") int channelId, @Param("agentId") int agentId, @Param("type") int type);

    int getOrderCount(@Param("channelId") int channelId, @Param("agentId") int agentId, @Param("type") int type,@Param("state") int state);

    int getPageViewCount(@Param("channelId") int channelId, @Param("agentId") int agentId, @Param("type") int type);

    List<Users> getAgentRegisterList(@Param("channelId") int channelId,@Param("type") int type,@Param("state") int state);

    List<Users> getAgentPageViewList(@Param("channelId") int channelId,@Param("agentId") int agentId,@Param("type") int type,@Param("state") int state);

    List<Users> getAgentOrderList(@Param("channelId") int channelId,@Param("type") int type,@Param("state") int state);

    Users getChannelRegister(@Param("channelId") int channelId,@Param("type") int type,@Param("state") int state);

    Users getChannelPageView(@Param("channelId") int channelId,@Param("type") int type,@Param("state") int state);

    Users getChannelOrder(@Param("channelId") int channelId,@Param("type") int type,@Param("state") int state);

    List<DiscountPackage> getOrderList(@Param("channelId") int channelId,@Param("agentId") int agentId,@Param("type") int type,@Param("state") int state);

    List<Users> getRegisterDetailList(@Param("channelId") int channelId,@Param("agentId") int agentId,@Param("type") int type);

    List<DiscountPackage> getOrderDetailList(@Param("channelId") int channelId,@Param("agentId") int agentId,@Param("type") int type,@Param("productId") int productId,@Param("state") int state);

    int insertAccessToken(AccessToken accessToken);

    AccessToken getAccessToken();

    int deleteToken();
}
