package com.sincere.wechatbusiness.model;


import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

@ApiModel
public class Coupon {
    private  Integer id;
    @ApiModelProperty(value = "优惠券编号")
    private  String  coupon_num;
    @ApiModelProperty(value = "优惠券类型")
    private  String  type;
    @ApiModelProperty(value = "减免金额")
    private  String  discount;
    @ApiModelProperty(value = "减免条件")
    private  String  condition;
    @ApiModelProperty(value = "有效期")
    private  String  expiry_date;
    @ApiModelProperty(value = "发放类型")
    private  Integer  sendtype;
    @ApiModelProperty(value = "发放对象号码")
    private  String  sendmobile;
    @ApiModelProperty(value = "账号项目名称")
    private  String  itemname;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private  Date start_time;
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private  Date end_time;

    private  String remark;

    private  String  state;
    private  Date create_time;

    @ApiModelProperty(value = "总优惠券数")
    private  Integer  allcount;
    @ApiModelProperty(value = "实际生成优惠券数")
    private  Integer actualcount;
    @ApiModelProperty(value = "已发放优惠券数")
    private  Integer  sendcount;
    @ApiModelProperty(value = "已兑换优惠券数")
    private  Integer  exchangecount;

    private String  url;

    private  Integer project_id;

    @ApiModelProperty(value = "0- 计划数内新增优惠券   1-计划数已经新增完了 再新增优惠券")
    private  Integer  flog;


    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getCoupon_num() {
        return coupon_num;
    }

    public void setCoupon_num(String coupon_num) {
        this.coupon_num = coupon_num;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getDiscount() {
        return discount;
    }

    public void setDiscount(String discount) {
        this.discount = discount;
    }

    public String getCondition() {
        return condition;
    }

    public void setCondition(String condition) {
        this.condition = condition;
    }

    public String getExpiry_date() {
        return expiry_date;
    }

    public void setExpiry_date(String expiry_date) {
        this.expiry_date = expiry_date;
    }

    public Integer getSendtype() {
        return sendtype;
    }

    public void setSendtype(Integer sendtype) {
        this.sendtype = sendtype;
    }

    public String getSendmobile() {
        return sendmobile;
    }

    public void setSendmobile(String sendmobile) {
        this.sendmobile = sendmobile;
    }

    public String getItemname() {
        return itemname;
    }

    public void setItemname(String itemname) {
        this.itemname = itemname;
    }

    public Date getStart_time() {
        return start_time;
    }

    public void setStart_time(Date start_time) {
        this.start_time = start_time;
    }

    public Date getEnd_time() {
        return end_time;
    }

    public void setEnd_time(Date end_time) {
        this.end_time = end_time;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public String getState() {
        return state;
    }

    public void setState(String state) {
        this.state = state;
    }

    public Date getCreate_time() { return create_time; }

    public void setCreate_time(Date create_time) { this.create_time = create_time; }


    public Integer getAllcount() {
        return allcount;
    }

    public void setAllcount(Integer allcount) {
        this.allcount = allcount;
    }

    public Integer getActualcount() {
        return actualcount;
    }

    public void setActualcount(Integer actualcount) {
        this.actualcount = actualcount;
    }

    public Integer getSendcount() {
        return sendcount;
    }

    public void setSendcount(Integer sendcount) {
        this.sendcount = sendcount;
    }

    public Integer getExchangecount() {
        return exchangecount;
    }

    public void setExchangecount(Integer exchangecount) {
        this.exchangecount = exchangecount;
    }

    public String getUrl() {
        return url;
    }

    public void setUrl(String url) {
        this.url = url;
    }

    public Integer getProject_id() {
        return project_id;
    }

    public void setProject_id(Integer project_id) {
        this.project_id = project_id;
    }

    public Integer getFlog() {
        return flog;
    }

    public void setFlog(Integer flog) {
        this.flog = flog;
    }
}
