package com.sincere.wechatbusiness.service;

import com.sincere.wechatbusiness.model.*;
import com.sincere.wechatbusiness.utils.Page;

import java.util.List;

public interface ChannelService {

    Page<Channel> getReportChannel(int page , int pageSize , String name);

    List<Channel> getListByTemplate(int templateId);

    Page<Channel> getList(Channel channel, int page, int pageSize);

    Channel getDetail(int id);

    int insert(Channel channel);

    int update(Channel channel);

    int deleteChannel(int id);

    int updateRoutine(int id ,String reportRoutineUrl);

    List<Area> getAreaList();

    List<Template> getTemplateList();

    Manager getManagerDetail(String mobile);

    int insertLog(Log log);

    int getRegisterCount(int channelId,int agentId,int type);

    int getPageViewCount(int channelId,int agentId,int type);

    int getOrderCount(int channelId,int agentId,int type);

    List<Users> getAgentRegisterList(int channelId,int type);

    List<Users> getAgentPageViewList(int channelId,int agentId ,int type);

    List<Users> getAgentOrderList(int channelId,int type);

    Users getChannelRegister(int channelId,int type);

    Users getChannelPageView(int channelId,int type);

    Users getChannelOrder(int channelId,int type);

    List<DiscountPackage> getOrderList(int channelId,int agentId,int type);

    List<Users> getRegisterDetailList(int channelId,int agentId,int type);

    List<DiscountPackage> getOrderDetailList(int channelId,int agentId,int type,int productId);

    int insertAccessToken(AccessToken accessToken);

    AccessToken getAccessToken();

    int deleteToken();
}
