package com.sincere.wechatbusiness.service.impl;

import com.sincere.wechatbusiness.mapper.BannerMapper;
import com.sincere.wechatbusiness.mapper.BannerNextMapper;
import com.sincere.wechatbusiness.model.Banner;
import com.sincere.wechatbusiness.model.BannerNext;
import com.sincere.wechatbusiness.service.BannerService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class BannerServiceImpl implements BannerService {
    @Autowired
    BannerMapper bannerMapper;

    @Autowired
    BannerNextMapper bannerNextMapper;

    @Override
    public List<Banner> getList(int id){return bannerMapper.getList(id);}

    @Override
    public int insert(Banner banner){return bannerMapper.insert(banner);}

    @Override
    public int update(Banner banner){return bannerMapper.update(banner);}

    @Override
    public int deleteBanner(int id){return bannerMapper.deleteBanner(id);}

    @Override
    public int deleteChannelBanner(int channelId) {
        return bannerMapper.deleteChannelBanner(channelId);
    }

    @Override
    public List<BannerNext> getBannerNextList(int channelId) {
        return bannerNextMapper.getByChannel(channelId);
    }

    @Override
    public int insertBannerNext(BannerNext bannerNext) {
        return bannerNextMapper.insert(bannerNext);
    }

    @Override
    public int deleteBannerNext(int id) {
        return bannerNextMapper.deleteByPrimaryKey(id);
    }

    @Override
    public int update(BannerNext bannerNext) {
        return bannerNextMapper.update(bannerNext);
    }

    @Override
    public int copy(Banner banner) {
        return bannerMapper.copy(banner);
    }

    @Override
    public int copyBannerNext(BannerNext bannerNext) {
        return bannerNextMapper.copy(bannerNext);
    }

    @Override
    public int deleteChannelBannerNext(int channelId) {
        return bannerNextMapper.deleteChannelBanner(channelId);
    }
}
