package com.sincere.wechatbusiness.service.impl;

import com.github.pagehelper.PageHelper;
import com.sincere.wechatbusiness.mapper.ChannelMapper;
import com.sincere.wechatbusiness.model.*;
import com.sincere.wechatbusiness.service.ChannelService;
import com.sincere.wechatbusiness.utils.Page;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class ChannelServiceImpl implements ChannelService {
    @Autowired
    ChannelMapper channelMapper;

    @Override
    public Page<Channel> getReportChannel(int page, int pageSize, String name) {
        Page<Channel> result=new Page<>(page,pageSize);
        PageHelper.startPage(page,pageSize);
        result.setList(channelMapper.getReportChannel(name));
        result.setCount(channelMapper.getReportChannelCount(name));
        return result;
    }

    @Override
    public List<Channel> getListByTemplate(int templateId) {
        return channelMapper.getListByTemplate(templateId);
    }

    @Override
    public Page<Channel> getList(Channel channel,int page, int pageSize){
        Page<Channel> result=new Page<>(page,pageSize);
        PageHelper.startPage(page,pageSize);
        result.setList(channelMapper.getList(channel));
        result.setCount(channelMapper.getListCount(channel));
        return result;
    }

    @Override
    public Channel getDetail(int id){
        Channel channel=new Channel();
        channel=channelMapper.getDetail(id);
        return channel;
    }

    @Override
    public int insert(Channel channel){return channelMapper.insert(channel);}

    @Override
    public int update(Channel channel){return channelMapper.update(channel);}

    @Override
    public int deleteChannel(int id){return channelMapper.deleteChannel(id);}

    @Override
    public int updateRoutine(int id, String reportRoutineUrl) {
        return channelMapper.updateRoutine(id,reportRoutineUrl);
    }

    @Override
    public List<Area> getAreaList(){
        List<Area> areaList=channelMapper.getProvince();
        for (Area area:areaList)
        {
            List<Area> areaList1=channelMapper.getCity(area.getValue());
            for(Area area1:areaList1)
            {
                area1.setChildren(channelMapper.getArea(area1.getValue()));
            }
            area.setChildren(areaList1);
        }
        return areaList;
    }

    @Override
    public List<Template> getTemplateList(){return channelMapper.getTemplateList();}

    @Override
    public Manager getManagerDetail(String mobile){return channelMapper.getManagerDetail(mobile);}

    @Override
    public int insertLog(Log log){return channelMapper.insertLog(log);}

    @Override
    public int getRegisterCount(int channelId,int agentId,int type){return channelMapper.getRegisterCount(channelId,agentId,type);}

    @Override
    public int getPageViewCount(int channelId, int agentId, int type) {
        return channelMapper.getPageViewCount(channelId,agentId,type);
    }

    @Override
    public int getOrderCount(int channelId,int agentId,int type){return channelMapper.getOrderCount(channelId,agentId,type,1);}

    @Override
    public List<Users> getAgentRegisterList(int channelId,int type){return channelMapper.getAgentRegisterList(channelId,type,1);}

    @Override
    public List<Users> getAgentPageViewList(int channelId,int agentId , int type) {
        return channelMapper.getAgentPageViewList(channelId,agentId,type,1);
    }

    @Override
    public List<Users> getAgentOrderList(int channelId,int type){return channelMapper.getAgentOrderList(channelId,type,1);}

    @Override
    public Users getChannelRegister(int channelId,int type){return channelMapper.getChannelRegister(channelId,type,1);}

    @Override
    public Users getChannelPageView(int channelId, int type) {
        return channelMapper.getChannelPageView(channelId,type,1);
    }

    @Override
    public Users getChannelOrder(int channelId,int type){return channelMapper.getChannelOrder(channelId,type,1);}

    @Override
    public List<DiscountPackage> getOrderList(int channelId,int agentId,int type){return channelMapper.getOrderList(channelId,agentId,type,1);}

    @Override
    public List<Users> getRegisterDetailList(int channelId,int agentId,int type){return channelMapper.getRegisterDetailList(channelId,agentId,type);}

    @Override
    public List<DiscountPackage> getOrderDetailList(int channelId,int agentId,int type,int productId){return channelMapper.getOrderDetailList(channelId,agentId,type,productId,1);}

    @Override
    public int insertAccessToken(AccessToken accessToken){return channelMapper.insertAccessToken(accessToken);}

    @Override
    public AccessToken getAccessToken(){return channelMapper.getAccessToken();}

    @Override
    public int deleteToken() {
        return channelMapper.deleteToken();
    }
}

